//----------------------------------------------------------------------//
// HTMLeLXgϊNX											//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <wininet.h>
#include <IdURI.hpp>
#include "UserFunc.h"
#include "htmconv.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//UTF8`FbN
//---------------------------------------------------------------------------
int check_UTF8(BYTE *bp, int size)
{
	int cnt = 0;
	try {
		int i = 0;
		while (i<size) {
			if (bp[i]<0x80)
				i++;
			else {
				int bn;
				if		(0xc2<=bp[i] && bp[i]<=0xdf) bn = 1;
				else if (0xe0<=bp[i] && bp[i]<=0xef) bn = 2;
				else if (0xf0<=bp[i] && bp[i]<=0xf4) bn = 3;
				else Abort();
				i++;	if (i==size) break;
				for (int j=0; j<bn && i<size; j++) {
					if (0x80<=bp[i] && bp[i]<=0xbf) {
						i++;	if (i==size) break;
					}
					else Abort();
				}
				cnt++;
			}
		}
	}
	catch (...) {
		cnt = 0;
	}
	return cnt;
}

//---------------------------------------------------------------------------
//[̃R[hy[W擾
// ߂l: R[hy[W (0:s)
//---------------------------------------------------------------------------
int get_MemoryCodePage(TMemoryStream *ms)
{
	int code_page = 0;

	int src_size = ms->Size;
	if (src_size==0) return 932;

	//\
	BYTE *bp = (BYTE *)ms->Memory;
	int x00_cnt	= 0;	//0x00 ̌
	int z_rpt	= 0;	//0x00 ̘A
	int z_max	= 0;	//0x00 ̍őA
	int esc_cnt = 0;	//ESC ̌
	int asc_cnt = 0;	//ASCII ̌
	int ltn_cnt = 0;	//ISO8859(Latin-1z) ̌
	int b7_cnt	= 0;	//b7==1 ̌

	for (int i=0; i<src_size; i++) {
		BYTE b0 = bp[i];
		if (b0==0x00) {
			x00_cnt++; z_rpt++;
		}
		else {
			if (z_rpt>z_max) z_max = z_rpt;
			z_rpt = 0;
			if		(b0==0x1b) 			 esc_cnt++;
			else if (0x06<b0 && b0<0x7f) asc_cnt++;
			else if (0xa0<=b0)			 ltn_cnt++;
			if ((b0 & 0x80)!=0)			 b7_cnt++;
		}
	}
	if (z_max>3 || (src_size<3 && x00_cnt>0)) return 0;	//oCi[

	//BOM̗L`FbN
	if		(bp[0]==0xfe && bp[1]==0xff)				code_page = 1201;		//UTF-16BE BOMt
	else if (bp[0]==0xff && bp[1]==0xfe)				code_page = 1200;		//UTF-16 (LE) BOMt
	else if (bp[0]==0xef && bp[1]==0xbb && bp[2]==0xbf)	code_page = CP_UTF8;	//UTF-8 BOMt
	if (code_page>0) return code_page;

	//BOM
	if (check_UTF8(bp, src_size)>0) code_page = CP_UTF8;	//UTF-8 BOM
	if (code_page>0) return code_page;

	if (x00_cnt==0) {
		if (esc_cnt>0) {
			//ISO-2022-JP?
			try {
				int jis_cnt = 0;
				int flag = 0;
				for (int i=0; i<src_size-1; i++) {
					BYTE b = bp[i];
					switch (flag) {
					case 0:
						if (b==0x1b) flag = 1;
						else if ((b>=0x80 && b<=0x8d) || (b>=0x90 && b<=0xa0) || b==0xfe) Abort();
						break;
					case 1:	//ESC
						flag = (b=='$')? 2 : (b=='(')? 5 : 0;
						break;
					case 2:	//ESC$
						flag = (b=='B' || b=='@')? 3 : 0;
						break;
					case 3:	//ESC$B/@
						if (b==0x1b) flag = 1; else jis_cnt++;
						break;
					case 5:	//ESC(
						flag = (b=='B' || b=='J')? 6 : 0;
						break;
					case 6:	//ESC(B/J
						if (b==0x1b) flag = 1; else jis_cnt++;
						break;
					}
				}
				if (jis_cnt > 0) code_page = 50220;
			}
			catch (...) {
				;
			}
		}
		else {
			//ShiftJIS?
			int sj_cnt	= 0;
			for (int i=0; i<src_size-1; i++) {
				BYTE b0 = bp[i];
				BYTE b1 = bp[i+1];
				if (((0x81<=b0 && b0<=0x9f) || (0xe0<=b0 && b0<=0xfc))
					&& ((0x40<=b1 && b1<=0x7e) || (0x80<=b1 && b1<=0xfc)))
				{
					sj_cnt += 2;  i++;
				}
			}
			//EUC-JP?
			int euc_cnt = 0;
			for (int i=0; i<src_size-1; i++) {
				BYTE b0 = bp[i];
				BYTE b1 = bp[i+1];
				if (((0xa1<=b0 && b0<=0xfe) && (0xa1<=b1 && b1<=0xfe))
					|| (b0==0x8e && (0xa1<=b1 && b1<=0xdf)))
						{ euc_cnt += 2;  i++; }
				else if (i<src_size-2) {
					BYTE b2 = bp[i+2];
					if (b0==0x8f && (0xa1<=b1 && b1<=0xfe) && (0xa1<=b2 && b2<=0xfe))
						{ euc_cnt += 3;  i += 2; }
				}
			}
			//UTF-7?
			int utf7_cnt = 0;
			if (b7_cnt==0) {
				int  b64cnt = 0;
				bool is_b64 = false;
				for (int i=0; i<src_size; i++) {
					BYTE b0 = bp[i];
					if (!is_b64) {
						if (b0=='+') {
							b64cnt = 0; is_b64 = true;
						}
					}
					else {
						if (b0=='-') {
							utf7_cnt += b64cnt;
							is_b64 = false;
						}
						else if (!isalnum(b0) && b0!='+' && b0!='/') {
							utf7_cnt = 0; break;
						}
						else b64cnt++;
					}
				}
			}
			if (euc_cnt+sj_cnt+asc_cnt > src_size/2) {
				if		(euc_cnt>sj_cnt)	code_page = 20932;
				else if (utf7_cnt>sj_cnt)	code_page = 65000;
				else if (sj_cnt>0)			code_page = 932;
				else if (ltn_cnt>0)			code_page = 1252;
				else if (asc_cnt==src_size)	code_page = 20127;
			}
		}
		if (code_page>0) return code_page;
	}

	//UTF-16?
	int be_asc = 1, le_asc = 1;
	int be_hk  = 1, le_hk  = 1;		//Ђ炪ȁAJ^Ji
	src_size -= (src_size%2);
	for (int i=0; i<src_size-1; i+=2) {
		BYTE b0 = bp[i];
		BYTE b1 = bp[i+1];
		if		(b0==0x00 && 0x1f<b1 && b1<0x7f) be_asc++;
		else if (b1==0x00 && 0x1f<b0 && b0<0x7f) le_asc++;
		else if (b0==0x30 && 0x00<b1 && b1<0xf7) be_hk++;
		else if (b1==0x30 && 0x00<b0 && b0<0xf7) le_hk++;
	}
	
	int be_point = 0, le_point = 0;
	if		(be_asc/le_asc>10) be_point++;
	else if (le_asc/be_asc>10) le_point++;
	if		(be_hk/le_hk>10)   be_point++;
	else if (le_hk/be_hk>10)   le_point++;

	if		(be_point>le_point) code_page = 1201;	//BE
	else if	(le_point>be_point) code_page = 1200;	//LE

	return code_page;
}

//---------------------------------------------------------------------------
// HtmConv NX
//---------------------------------------------------------------------------
HtmConv::HtmConv()
{
	HtmBuf = new TStringList();
	TxtBuf = new TStringList();

	TempDir 	 = EmptyStr;
	StatMsg		 = EmptyStr;

	OutCodePage  = 932;		//ShiftJIS

	LineWidth	 = DEF_LINE_WIDTH;
	ForceCr 	 = false;
	BlankLnLimit = DEF_BLANK_LN_LIMIT;
	NoPstHdr	 = false;
	HrLineStr	 = "-";
	IndentStr	 = "  ";
	UlMarkStr	 = "E";
	ZenNumber	 = false;

	UseAlt		 = false;
	AddImgSrc	 = false;
	DefAltStr	 = "摜";
	AltBraStr	 = "[";
	AltKetStr	 = "]";
	B_BraStr	 = EmptyStr;
	B_KetStr	 = EmptyStr;
	I_BraStr	 = EmptyStr;
	I_KetStr	 = EmptyStr;
	U_BraStr	 = EmptyStr;
	U_KetStr	 = EmptyStr;
	CellSepStr	 = "\t";

	InsLink 	 = false;
	OnlyExLink	 = true;
	AddCrLink	 = false;
	LnkBraStr	 = "<";
	LnkKetStr	 = ">";

	FileName	 = EmptyStr;
	FileTime	 = EmptyStr;

	HeadStr 	 = EmptyStr;
	FootStr 	 = EmptyStr;

	AlignList = new TStringList();
}

//---------------------------------------------------------------------------
HtmConv::~HtmConv()
{
	delete HtmBuf;
	delete TxtBuf;
	delete AlignList;
}

//---------------------------------------------------------------------------
//w^Oň͂܂ꂽ폜
//---------------------------------------------------------------------------
void HtmConv::DelTagBlock(TStringList *lst, UnicodeString start_wd, UnicodeString end_wd)
{
	bool flag = false;
	int i = 0;
	while (i<lst->Count) {
		UnicodeString s = lst->Strings[i];
		if (s.Pos("<")==1) s = s.UpperCase();
		if (!flag) {
			if (s.Pos(start_wd)==1) {
				flag = (s.Pos(end_wd)==0);
				lst->Delete(i);
			}
			else
				i++;
		}
		else {
			flag = (s.Pos(end_wd)==0);
			lst->Delete(i);
		}
	}
}

//---------------------------------------------------------------------------
//^O擾
//---------------------------------------------------------------------------
UnicodeString HtmConv::GetTag(UnicodeString s)
{
	UnicodeString retstr = EmptyStr;
	if (s.IsEmpty()) return retstr;

	int flag = 0;
	for (int i=1; i<=s.Length(); i++) {
		WideChar c = s[i];
		switch (flag) {
		case 0:
			if (c!='<') flag = -1; else flag = 1;
			break;
		case 1:
			if (c=='>' || c==' ')
				flag = -1;
			else
				retstr += UpperCase(c);
			break;
		}
		if (flag==-1) break;
	}
	return retstr;
}

//---------------------------------------------------------------------------
//vfw肵̒l擾
//---------------------------------------------------------------------------
UnicodeString HtmConv::GetTagAtr(UnicodeString s, UnicodeString t, UnicodeString a)
{
	UnicodeString retstr = EmptyStr;
	if (s.IsEmpty()) return retstr;
	int flag = 0;
	UnicodeString tag;
	UnicodeString atr;
	UnicodeString vstr;
	bool qflag;

	for (int i=1; i<=s.Length(); i++) {
		UnicodeString c = s.SubString(i,1);
		switch (flag) {
		case 0:
			if (c=="<") {
				tag  = EmptyStr;
				flag = 1;
			}
			break;
		case 1:
			if      (c==">") flag = 0;
			else if (c==" ") {	//^Om
				tag = tag.Trim();
				atr  = EmptyStr;
				flag = 2;
			}
			else tag += c;
			break;
		case 2:
			if (c=="=") {		//m
				atr = atr.Trim();
				flag = 3;
			}
			else if (c==">") flag = 0;
			else atr += c;
			break;
		case 3:
			if      (c==">") flag = 0;
			else if (c!=" ") {	//lJn
				qflag = (c=="\"");
				if (qflag) vstr = EmptyStr; else vstr = c;
				flag = 4;
			}
			break;
		case 4:
			if ((qflag && c=="\"") || (!qflag && (c==" " || c==">"))) {
				if (tag.CompareIC(t)==0 && atr.CompareIC(a)==0) {
					retstr = vstr;
					flag   = -1;	//lm!
				}
				else {
					atr = EmptyStr;
					if (c==">") flag = 0; else flag = 2;
				}
			}
			else vstr += c;
			break;
		}

		if (flag==-1) break;
	}

	return retstr;
}

//---------------------------------------------------------------------------
//̎QƂ̉
//---------------------------------------------------------------------------
UnicodeString HtmConv::RefEntity(UnicodeString s)
{
	if (s.IsEmpty()) return s;

	std::unique_ptr<TStringList> ent_lst(new TStringList());
	ent_lst->Text =
		"&quot;\t\"\r\n"
		"&lt;\t<\r\n"
		"&gt;\t>\r\n"
		"&nbsp;\t \r\n"
		"&#160;\t \r\n"
		"&yen;\t\\\r\n"
		"&#165;\t\\\r\n"
		"&copy;\t(c)\r\n"
		"&#169;\t(c)\r\n"
		"&reg;\t(R)\r\n"
		"&#174;\t(R)\r\n"
		"&deg;\t\r\n"
		"&#176;\t\r\n"
		"&plusmn;\t}\r\n"
		"&#177;\t}\r\n"
		"&ndash;\t-\r\n"
		"&#8211;\t-\r\n";

	s = replace_str_by_list(s, ent_lst.get());

	if (ContainsStr(s, "&")) {
		int stt = 0;
		int p = 1;
		int p0;
		while (p<=s.Length()) {
			if (s[p]=='&') {
				stt = 1;
				p++;
			}
			else {
				switch (stt) {
				case 1:
					if (s[p]=='#') {
						p0 = p+1;
						stt = 2;
					}
					else
						stt = 0;
					p++;
					break;
				case 2:
					if (s[p]==';') {
						int cn = s.SubString(p0, p-p0).ToIntDef(0);
						p0 -= 2;
						s.Delete(p0, p-p0+1);
						if (cn>=32 && cn<127)
							s.Insert(UnicodeString((char)cn), p0);
						else
							s.Insert("?", p0);
						p = p0+1;
						stt = 0;
					}
					else
						p++;
					break;
				default:
					p++;
				}
			}
		}
	}

	s = ReplaceStr(s, "&amp;", "&");

	return s;
}

//---------------------------------------------------------------------------
//HTML̃^Cg擾
//  fnam: HTML̃t@C
//---------------------------------------------------------------------------
UnicodeString HtmConv::GetTitle(UnicodeString fnam)
{
	UnicodeString titstr = EmptyStr;

	std::unique_ptr<TStringList> fbuf(new TStringList());
	fbuf->LoadFromFile(fnam);
	UnicodeString headstr = EmptyStr;
	int p = pos_i("</HEAD>", fbuf->Text);
	if (p>0) headstr = fbuf->Text.SubString(1,p+6);

	if (!headstr.IsEmpty()) {
		//charset `FbN
		int p = pos_i("charset", headstr);
		UnicodeString charset = EmptyStr;
		if (p>0) {
			UnicodeString tmpstr = headstr.SubString(p, headstr.Length()-p+1);
			tmpstr = get_tkn(get_tkn_r(tmpstr, "="), ">");
			if (!tmpstr.IsEmpty()) {
				p = tmpstr.Pos("\"");
				if (p>0) charset = tmpstr.SubString(1,p-1);
			}
		}

		//GR[fBOw肵čēǂݍ
		if (!charset.IsEmpty()) {
			int code_page = 0;
			if 		(charset.CompareIC("EUC-JP")==0)		code_page = 20932;
			else if (charset.CompareIC("ISO-2022-JP")==0)	code_page = 50220;
			else if (charset.CompareIC("UTF-8")==0)			code_page = CP_UTF8;
			if (code_page!=0) {
				std::unique_ptr<TEncoding> enc(TEncoding::GetEncoding(code_page));
				std::unique_ptr<TStringList> fbuf(new TStringList());
				fbuf->LoadFromFile(fnam, enc.get());
				headstr = EmptyStr;
				int p = pos_i("</HEAD>", fbuf->Text);
				if (p>0) headstr = fbuf->Text.SubString(1,p+6);
			}
		}

		//Rg폜
		int p0,p1;
		p0 = headstr.Pos("<!--");
		while (p0>0) {
			p1 = headstr.Pos("-->");
			if (p1>p0) {
				headstr.Delete(p0, p1-p0+3);
				p0 = headstr.Pos("<!--");
			}
			else {
				headstr = headstr.SubString(1,p1-1);
				break;
			}
		}

		//^Cg擾
		p0 = pos_i("<TITLE>",  headstr);
		p1 = pos_i("</TITLE>", headstr);
		if (p0>0 && p1>p0) titstr = headstr.SubString(p0+7, p1-p0-7);
	}
	return titstr;
}

//---------------------------------------------------------------------------
//t@C܂URLHTML\[XǂݍSHIFT-JIS ɕϊ
// fnam: HTMLt@CAV[gJbgt@CAURL
//---------------------------------------------------------------------------
bool HtmConv::LoadFile(UnicodeString fnam)
{
	HtmBuf->Clear();
	StatMsg = EmptyStr;
	UrlStr	= EmptyStr;
	BaseStr = EmptyStr;
	UnicodeString dl_file = EmptyStr;

	if (StartsText("http://", fnam) || StartsText("https://", fnam)) {
		try {
			UrlStr = fnam;
			if (UrlStr.Pos("%")==0) UrlStr = TIdURI::URLEncode(UrlStr, IndyTextEncoding_UTF8());
		}
		catch (Exception &exception) {
			;
		}
	}
	else if (ExtractFileExt(fnam).UpperCase()==".URL") {
		if (FileExists(fnam)) {
			std::unique_ptr<TStringList> tmplst(new TStringList());
			tmplst->LoadFromFile(fnam);
			for (int i=0; i<tmplst->Count; i++) {
				if (tmplst->Strings[i].Pos("URL=")!=1) continue;
				UrlStr = tmplst->Strings[i].Delete(1,4);
				break;
			}
		}
		else return false;
	}

	if (!UrlStr.IsEmpty()) {
		//C^[lbgHTML擾
		BaseStr = UrlStr;
		if (BaseStr[BaseStr.Length()]!='/') {
			UnicodeString tmpstr = BaseStr;
			tmpstr.Delete(1,7);
			if (tmpstr.Pos("/")==0)
				BaseStr += "/";
			else {
				int i = BaseStr.Length();
				while (i>7) {
					if (BaseStr[i]=='/') break;
					BaseStr.Delete(i--,1);
				}
			}
		}

		DWORD flag;
		if (InternetGetConnectedState(&flag, 0)) {
			HINTERNET hSession = InternetOpen(
				_T("H2Tconv"), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
			if (hSession) {
				HINTERNET hConnect = InternetOpenUrl(hSession,
				    UrlStr.c_str(), NULL, 0, INTERNET_FLAG_RELOAD, 0);
				if (hConnect) {
					dl_file = TempDir+"\\$$~DOWLD.tmp";
					{
						std::unique_ptr<TFileStream> dfs(new TFileStream(dl_file, fmCreate));
						DWORD dwSize;
						char ldbuf[8192];
						for (;;) {
							if (!InternetReadFile(hConnect, &ldbuf, 8192, &dwSize)) break;
							if (dwSize==0) break;
							dfs->Write(ldbuf, dwSize);
						}
					}
					InternetCloseHandle(hConnect);
					HtmBuf->LoadFromFile(dl_file);
				}
				else
					StatMsg = "wURLJ";
			    InternetCloseHandle(hSession);
			}
			else
				StatMsg = "ڑł܂";
			FileName = EmptyStr;
			FileTime = DateTimeToStr(Now());
		}
		else
			StatMsg = "C^[lbgɐڑĂ܂";
	}
	//t@Cǂݍ
	else {
		if (FileExists(fnam)) {
			HtmBuf->LoadFromFile(fnam);
			FileName = fnam;
			TDateTime ft; if (!FileAge(fnam, ft)) ft = 0;
			FileTime = DateTimeToStr(ft);
		}
		else
			return false;
	}

	//KvȂGR[fBOw肵čēǂݍ
	if (HtmBuf->Count>0) {
		UnicodeString tmpbuf  = HtmBuf->Text;
		UnicodeString charset = EmptyStr;
		do {
			//wb_o
			int p = pos_i("</head>", tmpbuf);  if (p==0) break;
			if (p>0) tmpbuf = tmpbuf.SubString(1,p-1);

			//R[hw肳Ă邩ׂ
			std::unique_ptr<TStringList> tmplst(new TStringList());
			tmplst->Text = tmpbuf;
			for (int i=0; i<tmplst->Count; i++) {
				UnicodeString lbuf = tmplst->Strings[i];
				UnicodeString tmpstr = GetTagAtr(lbuf, "META", "charset");
				if (!tmpstr.IsEmpty()) {
					charset = tmpstr; break;
				}
				tmpstr = GetTagAtr(lbuf, "META", "http-equiv");
				if (tmpstr.IsEmpty()) continue;
				tmpstr = GetTagAtr(lbuf, "META", "content");
				if ((p = pos_i("charset", tmpstr)) == 0) continue;;
				tmpstr.Delete(1, p-1);
				if ((p = tmpstr.Pos("=")) == 0) continue;
				charset = tmpstr.Delete(1,p).Trim();
				break;
			}
		} while (0);

		int code_page = 0;
		if (!charset.IsEmpty()) {
			if		(SameText(charset, "Shift_JIS"))	code_page = 932;
			else if	(SameText(charset, "EUC-JP"))		code_page = 20932;
			else if (SameText(charset, "ISO-2022-JP"))	code_page = 50220;
			else if (SameText(charset, "UTF-8"))		code_page = CP_UTF8;
		}
		//charset w肳ĂȂ玩OŃR[h
		if (code_page==0) {
			std::unique_ptr<TMemoryStream> ms(new TMemoryStream());
			ms->LoadFromFile(dl_file.IsEmpty()? fnam : dl_file);
			code_page = get_MemoryCodePage(ms.get());
		}

		//GR[fBOw肵čēǂݍ
		if (code_page!=0 && code_page!=932) {
			std::unique_ptr<TEncoding> enc(TEncoding::GetEncoding(code_page));
			HtmBuf->LoadFromFile(dl_file.IsEmpty()? fnam : dl_file, enc.get());
		}
		if (!dl_file.IsEmpty()) DeleteFile(dl_file);
		return true;
	}
	else
		return false;
}

//---------------------------------------------------------------------------
//TxtLineBuf 𐮌` TxtBuf 
//---------------------------------------------------------------------------
void HtmConv::FlushText()
{
	if (TxtLineBuf.IsEmpty()) return;
	if (!Skip) {
		//L̕ϊ
		if (!fXMP) TxtLineBuf = RefEntity(TxtLineBuf);

		//AC
		if (!fPRE && !fXMP && AlignList->Count>0) {
			UnicodeString a = AlignList->Strings[AlignList->Count-1];
			int len = TxtLineBuf.Length();
			if (len>0 && len<LineWidth) {
				UnicodeString s = EmptyStr;
				if (a=="CENTER")
					s = UnicodeString::StringOfChar(' ', (LineWidth-len)/2);
				else if (a=="RIGHT")
					s = UnicodeString::StringOfChar(' ', LineWidth-len);
				TxtLineBuf = s + TxtLineBuf;
			}
		}

		if (fPRE || fXMP)
	 		TxtBuf->Add(TxtLineBuf);
		else if (ForceCr) {
			//w茅ŋs
			UnicodeString tmpstr = TxtLineBuf;
			while (tmpstr.Length()>LineWidth) {
				int w = LineWidth;
				TxtBuf->Add(tmpstr.SubString(1,w));
		 		tmpstr.Delete(1,w);
			}
			if (!tmpstr.IsEmpty()) {
				UnicodeString s = trim_ex(TxtLineBuf);
				if (s.IsEmpty())
					TxtBuf->Add(EmptyStr);
				else
					TxtBuf->Add(tmpstr);
			}
		}
		else {
			UnicodeString s = trim_ex(TxtLineBuf);
			if (s.IsEmpty())
				TxtBuf->Add(EmptyStr);
			else
				TxtBuf->Add(TxtLineBuf);
		}
	}
	TxtLineBuf = EmptyStr;
}

//---------------------------------------------------------------------------
//ϊ
//---------------------------------------------------------------------------
void HtmConv::Convert()
{
	StatMsg = EmptyStr;

	std::unique_ptr<TStringList> TmpBuf(new TStringList());

	//------------------------------
	//^Osɕ
	//------------------------------
	TmpBuf->Clear();
	for (int i=0; i<HtmBuf->Count; i++) {
		UnicodeString s = HtmBuf->Strings[i];
		if (!s.IsEmpty()) {
			for (;;) {
				int p0 = s.Pos("<");
				int p1 = s.Pos(">");
				if (p0>1) {
					if (p1>0) {
						if (p0<p1) {
							TmpBuf->Add(s.SubString(1, p0-1));
							s.Delete(1, p0-1);
						}
						else {
							TmpBuf->Add(s.SubString(1, p1));
							s.Delete(1, p1);
						}
					}
					else {
						TmpBuf->Add(s.SubString(1, p0-1));
						s.Delete(1, p0-1);
					}
				}
				else {
					if (p1>0) {
						TmpBuf->Add(s.SubString(1, p1));
						s.Delete(1, p1);
					}
					else break;
				}
			}
			if (!s.IsEmpty()) TmpBuf->Add(s);
		}
		TmpBuf->Add("</>");	//s}[N
	}

	//------------------------------
	//Rg폜
	//------------------------------
	DelTagBlock(TmpBuf.get(), "<!--", "-->");

	//------------------------------
	//scriptAsytle 폜
	//RgAEgĂȂꍇ̑΍
	//------------------------------
	DelTagBlock(TmpBuf.get(), "<SCRIPT", 	"</SCRIPT>");
	DelTagBlock(TmpBuf.get(), "<NOSCRIPT","</NOSCRIPT>");
	DelTagBlock(TmpBuf.get(), "<STYLE",	"</STYLE>");

	//------------------------------
	//sfĂ^OA
	//------------------------------
	int i = 0;
	bool flag = false;
	while (i<TmpBuf->Count) {
		UnicodeString s = TmpBuf->Strings[i];
		if (!flag) {
			if (!s.IsEmpty()) flag = (s[1]=='<' && s[s.Length()]!='>');
			i++;
		}
		else {
			if (s=="</>")
				TmpBuf->Delete(i);
			else {
				if (!s.IsEmpty()) {
					if (s[s.Length()]=='>') flag = false;
				}
				TmpBuf->Strings[i-1] = TmpBuf->Strings[i-1] + " " + TmpBuf->Strings[i];
				TmpBuf->Delete(i);
			}
		}
	}

	//------------------------------
	//]ȔpXy[X폜
	//------------------------------
	fPRE = fXMP = false;
	i = 0;
	while (i<TmpBuf->Count) {
		UnicodeString s = TmpBuf->Strings[i];
		UnicodeString tag = GetTag(s);
		if (fPRE) {
			if (tag=="/PRE") fPRE = false;
			i++;
		}
		else if (fXMP) {
			if (tag=="/XMP") fXMP = false;
			i++;
		}
		else if (!tag.IsEmpty()) {
			if		(tag=="PRE")  fPRE = true;
			else if (tag=="XMP")  fXMP = true;
			TmpBuf->Strings[i++] = s.Trim();
		}
		else {
			//ApXy[X
			s = s.Trim();
			while (s.Pos("  ")>0) s = ReplaceStr(s, "  ", " ");
			if (s.IsEmpty())
				TmpBuf->Delete(i);
			else
				TmpBuf->Strings[i++] = s;
		}
	}

	//------------------------------
	//ϊ
	//------------------------------
	AlignList->Clear();
	int  DL_level = 0;
	int  LI_level = 0;
	int  LI_No[100];
	char OL_type[100];
	int  fTR    = 0;
	int  fTITLE = 0;
	int  fP_al  = 0;
	int  fTABLE = 0;
	bool pstHdr = false;
	fPRE = fXMP = false;
	Skip = false;

	TxtLineBuf = EmptyStr;
	TitleStr   = EmptyStr;
	UnicodeString tmpstr, HrefStr;
	UnicodeString DescrStr = EmptyStr;
	UnicodeString KeywdStr = EmptyStr;

	int topline = TxtBuf->Count;

	for (int i=0; i<TmpBuf->Count; i++) {
		UnicodeString lbuf = TmpBuf->Strings[i];
		UnicodeString tag  = GetTag(lbuf);
		if (tag.IsEmpty()) {
			pstHdr = false;
			if (fTITLE)
				TitleStr += lbuf;
			else if (fPRE || fXMP)
				TxtLineBuf += lbuf;
			else if (!Skip) {
				//pԂɃXy[X}
				do {
					if (TxtLineBuf.IsEmpty() || lbuf.IsEmpty()) break;
					if (StrByteType(TxtLineBuf.c_str(), TxtLineBuf.Length()-1) != mbSingleByte) break;
					if (StrByteType(lbuf.c_str(), 0) != mbSingleByte) break;
					if (TxtLineBuf[TxtLineBuf.Length()]==' ') break;
					if (lbuf[1]==' ') break;
					TxtLineBuf += " ";
				} while (0);
				TxtLineBuf += lbuf;
			}
		}
		else {
			//<P> u[NꂽH
			if (fP_al>0 && contains_word(
				"H1|H2|H3|H4|H5|H6|P|HR|DIV|CENTER|BLOCKQUOTE|TABLE|TR|TH|TD|UL|OL|DL|LI|PRE|XMP", tag))
			{
				FlushText();
				if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
				fP_al--;
			}

			if (tag=="/") {
				if (fPRE || fXMP) {
					UnicodeString s = trim_ex(TxtLineBuf);
					if (s.IsEmpty())
				 		TxtBuf->Add(TxtLineBuf);
					else
						FlushText();
				}
			}
			else if (tag=="/XMP") {
				FlushText();	fXMP = false;
			}
			else if (fXMP) {
				TxtLineBuf += lbuf;
			}
			else if (tag=="B")  TxtLineBuf += B_BraStr;
			else if (tag=="/B") TxtLineBuf += B_KetStr;
			else if (tag=="I")  TxtLineBuf += I_BraStr;
			else if (tag=="/I") TxtLineBuf += I_KetStr;
			else if (tag=="U")  TxtLineBuf += U_BraStr;
			else if (tag=="/U") TxtLineBuf += U_KetStr;
			else if (tag=="P") {
				FlushText();
				if (!pstHdr) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				if (fTABLE==0) {
					tmpstr = GetTagAtr(lbuf, tag, "ALIGN").UpperCase();
					if (tmpstr.IsEmpty() && AlignList->Count>0)
						tmpstr = AlignList->Strings[AlignList->Count-1];
					AlignList->Add(tmpstr);
				}
				else
					AlignList->Add(EmptyStr);
				fP_al++;
			}
			else if (tag=="/P") {
				FlushText();
				if (fP_al>0) {
					if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
					fP_al--;
				}
			}
			else if (contains_word("BR|BR/|BR /", tag)) {
				if (!TxtLineBuf.IsEmpty()) FlushText(); else TxtBuf->Add(EmptyStr);
				for (int j=0; j<(LI_level+DL_level); j++) TxtLineBuf += IndentStr;
			}
			else if (tag=="PRE") {
				FlushText();	fPRE = true;
			}
			else if (tag=="/PRE") {
				FlushText();	fPRE = false;
			}
			else if (tag=="XMP") {
				FlushText();	fXMP = true;
			}
			else if (tag=="CENTER") {
				FlushText();
				AlignList->Add("CENTER");
			}
			else if (tag=="/CENTER") {
				FlushText();
				if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
			}
			else if (tag=="DIV") {
				FlushText();
				AlignList->Add(GetTagAtr(lbuf, tag, "ALIGN").UpperCase());
			}
			else if (tag=="/DIV") {
				FlushText();
				if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
			}
			else if (contains_word("H1|H2|H3|H4|H5|H6", tag)) {
				FlushText();
				if (!pstHdr && TxtBuf->Count>0) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				TxtLineBuf = HeaderStr[tag.SubString(2,1).ToIntDef(1)-1];
			}
			else if (contains_word("/H1|/H2|/H3|/H4|/H5|/H6", tag)) {
				FlushText();
				if (NoPstHdr) pstHdr = true;
			}
			else if (tag=="HR") {
				FlushText();
				if (!HrLineStr.IsEmpty()) {
					tmpstr = GetTagAtr(lbuf, tag, "WIDTH").UpperCase();
					int n = std::max(LineWidth/HrLineStr.Length(), 1);
					if (!tmpstr.IsEmpty()) {
						if (tmpstr[tmpstr.Length()]=='%') {
							tmpstr.Delete(tmpstr.Length(),1);
							n = std::min(tmpstr.ToIntDef(100), 100);
							n = std::max((LineWidth/HrLineStr.Length())*n/100, 1);
							tmpstr = GetTagAtr(lbuf, tag, "ALIGN").UpperCase();
							if (tmpstr.IsEmpty()) tmpstr = "CENTER";
							AlignList->Add(tmpstr);
							for (int j=0; j<n; j++) TxtLineBuf += HrLineStr;
							FlushText();
							AlignList->Delete(AlignList->Count-1);
						}
						else {
							for (int j=0; j<n; j++) TxtLineBuf += HrLineStr;
							FlushText();
						}
					}
					else {
						for (int j=0; j<n; j++) TxtLineBuf += HrLineStr;
						FlushText();
					}
				}
			}
			else if (tag=="UL") {
				FlushText();
				if ((LI_level==0) && !pstHdr) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				LI_No[++LI_level] = -1;
			}
			else if (tag=="OL") {
				FlushText();
				if (LI_level==0 && !pstHdr) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				LI_No[++LI_level] = GetTagAtr(lbuf, tag, "START").ToIntDef(1);
				tmpstr = GetTagAtr(lbuf, tag, "TYPE");
				if (tmpstr.IsEmpty()) OL_type[LI_level] = '1'; else OL_type[LI_level] = tmpstr[1];
			}
			else if (tag=="/UL" || tag=="/OL") {
				FlushText();
				LI_level = std::max(LI_level-1, 0);
			}
			else if (tag=="LI") {
				FlushText();
				if (LI_level>0) {
					//tXg
					int n = LI_level + DL_level;
					for (int j=0; j<n; j++) TxtLineBuf += IndentStr;
					if (LI_No[LI_level]>0) {
						n = LI_No[LI_level];
						switch (OL_type[LI_level]) {
						case '1': tmpstr = IntToStr(n); 				break;
						case 'a': tmpstr = int_to_alpha(n); 			break;
						case 'A': tmpstr = int_to_alpha(n).UpperCase(); break;
						case 'i': tmpstr = int_to_roman(n); 			break;
						case 'I': tmpstr = int_to_roman(n).UpperCase(); break;
						}
						tmpstr += ".";
						if (ZenNumber) tmpstr = to_zenstr(tmpstr);
						TxtLineBuf += tmpstr;
						LI_No[LI_level]++;
					}
					else
						//Xg
						TxtLineBuf += UlMarkStr;
				}
			}
			else if (tag=="DL") {
				FlushText();
				if (DL_level==0 && !pstHdr) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				DL_level++;
			}
			else if (tag=="/DL") {
				FlushText();
				DL_level = std::max(DL_level-1, 0);
			}
			else if (tag=="DT") {
				FlushText();
				if (DL_level>0) {
					int n = LI_level + DL_level-1;
					for (int j=0; j<n; j++) TxtLineBuf += IndentStr;
				}
			}
			else if (tag=="DD") {
				if (DL_level>0) {
					FlushText();
					int n = LI_level + DL_level;
					for (int j=0; j<n; j++) TxtLineBuf += IndentStr;
				}
			}
			else if (tag=="TABLE") {
				FlushText();
				if (!pstHdr) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				AlignList->Add(EmptyStr);
				fTABLE++;
			}
			else if (tag=="/TABLE") {
				FlushText();
				if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
				fTABLE--;
			}
			else if (contains_word("CAPTION|/TR|/CAPTION", tag)) {
				FlushText();
			}
			else if (tag=="TD" || tag=="TH") {
				if (fTR>0)
					fTR = 0;
				else
					if (!TxtLineBuf.IsEmpty()) TxtLineBuf += CellSepStr;
			}
			else if (tag=="TR") {
				FlushText();
				fTR = 1;
			}
			else if (tag=="A" && InsLink) {
				HrefStr = GetTagAtr(lbuf, tag, "HREF");
				if (OnlyExLink) {
					if (HrefStr.Pos("http:")!=1 && HrefStr.Pos("mailto:")!=1)
						HrefStr = EmptyStr;
				}
				//\ȂΎw
				do {
					if (HrefStr.IsEmpty()) break;
					if (HrefStr.Pos("file:")==1) break;
					if (HrefStr.Pos("http:")==1) break;
					if (HrefStr.Pos("mailto:")==1) break;
					if (BaseStr.IsEmpty()) break;
					HrefStr = BaseStr + HrefStr;
				} while (0);
			}
			else if (tag=="/A" && InsLink) {
				if (!HrefStr.IsEmpty()) {
					tmpstr = LnkBraStr + HrefStr + LnkKetStr;
					if (AddCrLink) tmpstr = "\r\n" + tmpstr + "\r\n";
					TxtLineBuf += tmpstr;
				}
				HrefStr = EmptyStr;
			}
			else if (tag=="IMG" && (UseAlt || AddImgSrc)) {
				TxtLineBuf += AltBraStr;
				if (UseAlt) {
					tmpstr = GetTagAtr(lbuf, tag, "ALT");
					if (tmpstr.IsEmpty()) tmpstr = DefAltStr;
					TxtLineBuf += tmpstr;
				}
				if (AddImgSrc) {
					tmpstr = GetTagAtr(lbuf, tag, "SRC");
					if (!tmpstr.IsEmpty()) {
						//\ȂΎw
						do {
							if (tmpstr.Pos("file:")==1) break;
							if (tmpstr.Pos("http:")==1) break;
							if (BaseStr.IsEmpty()) break;
							tmpstr = BaseStr + tmpstr;
						} while (0);
						if (UseAlt) TxtLineBuf += " ";
						TxtLineBuf += tmpstr;
					}
				}
				TxtLineBuf += AltKetStr;
			}
			else if (tag=="HEAD")
				Skip = true;
			else if (tag=="/HEAD" || tag=="BODY") {
				Skip   = false;
				fTITLE = 0;
			}
			else if (tag=="TITLE")
				fTITLE ++;
			else if (tag=="/TITLE")
				fTITLE = 0;
			else if (tag=="BASE") {
				tmpstr = GetTagAtr(lbuf, tag, "HREF");
				if (!tmpstr.IsEmpty()) {
					if (tmpstr[tmpstr.Length()]!='/') tmpstr += "/";
					BaseStr = tmpstr;
				}
			}
			else if (tag=="META") {
				tmpstr = GetTagAtr(lbuf, tag, "NAME");
				if (!tmpstr.IsEmpty()) {
					if (tmpstr.CompareIC("description")==0)
						DescrStr = GetTagAtr(lbuf, tag, "CONTENT");
					else
					if (tmpstr.CompareIC("keywords")==0)
						KeywdStr = GetTagAtr(lbuf, tag, "CONTENT");
				}
			}
		}
	}
	FlushText();

	TitleStr = RefEntity(TitleStr);

	//As̐
	i = topline;
	int blkln = 0;
	while (i<TxtBuf->Count) {
		if (TxtBuf->Strings[i].IsEmpty()) {
			blkln++;
			if (blkln>BlankLnLimit) TxtBuf->Delete(i); else i++;
		}
		else {
			blkln = 0;
			i++;
		}
	}

	//wb_Etb^̑}
	TmpBuf->Clear();
	for (int lopn = 0; lopn<2; lopn++) {
		if (lopn==0)
			TmpBuf->Text = HeadStr;
		else
			TmpBuf->Text = FootStr;
		if (TmpBuf->Count==0) continue;

		for (int i=0; i<TmpBuf->Count; i++) {
			//̓WJ
			UnicodeString s = TmpBuf->Strings[i];
			for (int j=0; j<9; j++) {
				UnicodeString swd,rwd;
				switch (j) {
				case  0: swd = "$TITLE"; rwd = TitleStr;				  break;
				case  1: swd = "$DTIME"; rwd = DateTimeToStr(Now());	  break;
				case  2:
					swd = "$FNAME";
					if (!UrlStr.IsEmpty())
						rwd = UrlStr;
					else
						rwd = ExtractFileName(FileName);
					break;
				case  3:
					swd = "$FTIME"; rwd = FileTime;	break;
				case  4:
					swd = "$LINE1";
					rwd = UnicodeString::StringOfChar('-', LineWidth);
					break;
				case  5:
					swd = "$LINE2";
					rwd = EmptyStr;
					for (int k=0; k<LineWidth/2; k++) rwd += "";
					break;
				case  6:
					swd = "$LINE3";
					rwd = EmptyStr;
					for (int k=0; k<LineWidth/2; k++) rwd += "";
					break;
				case  7:
					swd = "$DESCR"; rwd = DescrStr; break;
				case  8:
					swd = "$KEYWD"; rwd = KeywdStr; break;
				}
				s = ReplaceStr(s, swd, rwd);
			}
			//eLXgɑ}
			if (lopn==0)
				TxtBuf->Insert(topline+i, s);	//wb_
			else
				TxtBuf->Add(s);	//tb^
		}
	}
}
//---------------------------------------------------------------------------
//wR[hŃt@Cɕۑ
//---------------------------------------------------------------------------
bool HtmConv::SaveToFileCP(UnicodeString fnam)
{
	try {
		std::unique_ptr<TEncoding> enc(TEncoding::GetEncoding(OutCodePage));
		TxtBuf->SaveToFile(fnam, enc.get());
		return true;
	}
	catch (...) {
		return false;
	}
}
//---------------------------------------------------------------------------
